﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Wpf_C1Flex_TextForeColor
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            #region "Data"

            var list = new List<TestData>();
            list.Add(new TestData() { Name = "Jason Bourne", Title = "Mr." });
            list.Add(new TestData() { Name = "Marie St.Jacques", Title = "Mrs." });
            list.Add(new TestData() { Name = "Alexander Conklin", Title = "Mr." });
            list.Add(new TestData() { Name = "David Webb", Title = "Mr." });
            list.Add(new TestData() { Name = "Gordon Webb", Title = "Mr." });
            list.Add(new TestData() { Name = "Joshua Webb", Title = "Master" });

            #endregion

            c1FlexGrid1.ItemsSource = list;
            c1DataGrid1.ItemsSource = list;

            string _text = string.Empty;

            button1.Click += (s, e) =>
            {
                _text = this.textBox1.Text;
                //refresh both Grids each time button is clicked for a new search
                c1FlexGrid1.CellFactory = new MyCellFactory(_text);
                c1DataGrid1.Refresh();
            };         

            c1DataGrid1.LoadedCellPresenter += (s, e) =>
            {
                //Get TextBlock using DataGridCellPresenter
                var presenter = ((C1.WPF.DataGrid.DataGridCellPresenter)(e.Cell.Presenter));
                var textblock = ((System.Windows.Controls.TextBlock)(((System.Windows.FrameworkElement)(presenter.Content))));
                if (textblock != null && _text != null)
                {
                    if (textblock.Text.Contains(_text))
                    {
                        //Call method from static class to change text Foreground
                        Range.Find(_text, textblock);
                    }
                }
            };
        }
    }

    //Custom CellFactory
    public class MyCellFactory : C1.WPF.FlexGrid.CellFactory
    {
        string _text;

        public MyCellFactory()
        { }

        public MyCellFactory(string text)
        {
            _text = text;
        }

        public override void CreateCellContent(C1.WPF.FlexGrid.C1FlexGrid grid, Border bdr, C1.WPF.FlexGrid.CellRange range)
        {
            base.CreateCellContent(grid, bdr, range);
            if (range.Row >= grid.Rows[0].Index && range.Column >= grid.Columns[0].Index)
            {
                //Fetch text from TextBlock
                var tb = bdr.Child as TextBlock;
                if (tb != null)
                {
                    if (tb.Text.Contains(_text))
                    {
                        //Call method from static class to change text Foreground
                        Range.Find(_text, tb);
                    }
                }
            }
        }
    }

    public class TestData
    {
        public string Name { get; set; }
        public string Title { get; set; }
    }

   
    public static class Range
    {
        public static void Find(string text, TextBlock _tb)
        {
            var tb = _tb as TextBlock;

            var si = tb.Text.IndexOf(text);
            // TextPointer to the position indicated by the specified offset 
            // from the beginning of the current TextPointer
            var sp = tb.ContentStart.GetPositionAtOffset(si + 1);
            var ep = tb.ContentStart.GetPositionAtOffset(si + text.Length + 1);

            //Change ForeGround and FontWeight of the specified TextRange
            TextRange tr = new TextRange(sp, ep);
            tr.ApplyPropertyValue(TextElement.ForegroundProperty, Brushes.Red);
            tr.ApplyPropertyValue(TextElement.FontWeightProperty, FontWeights.Bold);
        }
    }

}
